/* include/outils.h - Divers outils
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs_and_davidounet@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: outils.h,v 1.3 2003/12/27 16:18:19 romexzf Exp $
 */

#ifndef HAVEINC_outils
#define HAVEINC_outils

#ifdef HAVE_CRYPTHOST
extern char *hostprot(const char *);
#endif

extern int match(const char *, const char *); /* hack*/
extern char *mkpass(const char *); /* hack*/

extern int chan_check(const char *, aNick *);
extern int is_num(const char *);
extern int is_ip(const char *);
extern void strupr(char *);
extern void strlwr(char *);
extern void conv_char(const char *, char *);
extern void strip_newline(char *);

extern anUser *GetUserIbyMail(const char *);
extern int ChanLevelbyUserI(anUser *, aChan *);
extern aJoin *getjoininfo(aNick *, const char *);
extern struct badnicks *getbadnick(const char *);
extern int IsBadNick(const char *);
extern struct badchans *getbadchan(const char *);
extern char *IsAnOwner(anUser *);
extern anAccess *GetAccessIbyUserI(anUser *, aChan *);
extern aNick *GetMemberIbyNum(aChan *, const char *);
extern aNick *GetMemberIbyNick(aChan *, const char *);

extern int getoption(const char *, char **, int, int, int);

extern aServer *num2servinfo(const char *);
extern aServer *GetLinkIbyServ(const char *);
extern void parv2msgn(unsigned int, char **, unsigned int, char *, unsigned int);
extern char *parv2msg(unsigned int, char **, unsigned int, unsigned int);

extern char *duration(int);
extern time_t convert_duration(const char *);
extern char *get_time(time_t);

extern char *GetNUHbyNick(aNick *, int);
extern char *GetPrefix(aNick *);
extern char *GetChanPrefix(aNick *, aJoin *, int);
extern char *GetUserOptions(anUser *);
extern char *GetAccessOptions(anAccess *);
extern char *GetChanOptions(aChan *);

extern int checkpass(const char *, anUser *);
extern void putlog(const char *, const char *, ...);
extern char *make_servnum(int);
extern unsigned long int resolve(const char *);
extern int check_protect(aNick *, aNick *, aChan *);

extern int parse_umode(int, const char *);
extern char *GetModes(int);
extern int cmodetoflag(int, const char *);
extern int string2scmode(struct cmode *, const char *, const char *, const char *);
extern char *GetCModes(struct cmode);

extern int IsValidNick(char *);
extern int IsValidMail(char *);

extern int GetCmdIndexbyName(const char *);
extern int GetCurCmdIndexbyName(const char *);
extern char *RealCmd(const char *);

extern anUser *ParseNickOrUser(aNick *, char *);
extern void File_UserDel(char *);

extern char *str_dup(char **, const char *);
extern char *Strncpy(char *, const char *, size_t);
extern char *Strtok(char **, char *, char);

extern int switch_option(aNick *, const char *, const char *, const char *, int *, int);
#endif /*HAVEINC_outils*/
