/* src/chaninfo.c - Lire les informations  propos d'un salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * $Id: chaninfo.c,v 1.36 2003/12/27 16:19:25 romexzf Exp $
 */

#include "main.h"
#include "outils.h"
#include "ban.h"
#include "cs_cmds.h"
#include "admin_chan.h"

/*
 * chaninfo #salon
 */
int chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = chaninfo->access;
	int see = (IsAnAdmin(nick->user) || (nick->user && GetAccessIbyUserI(nick->user, chaninfo)));

	if(chaninfo->mode.modes & (C_MSECRET | C_MPRIVATE) /* salon +s ou +p */
		&& !see && !getjoininfo(nick, chaninfo->chan)) /* ET ni admin/accs, ni prsent */
			return csntc(nick, GetReply(nick, L_YOUNOACCESSON), chaninfo->chan);

	for(;lp && lp->value.a->level != OWNERLEVEL;lp = lp->next);/* recherche de l'owner*/

	csntc(nick, GetReply(nick, L_INFO_ABOUT), parv[1]);
	csntc(nick, GetReply(nick, L_CIOWNER), lp ? lp->value.a->user->nick : "Aucun",
		chaninfo->creation_time ? get_time(chaninfo->creation_time) : "- Non dfini -");
	csntc(nick, GetReply(nick, L_CIDESCRIPTION), chaninfo->description);

	if(see || !(chaninfo->defmodes.modes & C_MKEY))
		csntc(nick, GetReply(nick, L_CIDEFMODES), GetCModes(chaninfo->defmodes));

	csntc(nick, GetReply(nick, L_CIDEFTOPIC), chaninfo->deftopic);
	if(see && chaninfo->motd) csntc(nick, GetReply(nick, L_CIMOTD), chaninfo->motd);
	csntc(nick, GetReply(nick, L_CICHANURL), chaninfo->url);

	csntc(nick, GetReply(nick, L_CIOPTIONS), GetChanOptions(chaninfo));
	csntc(nick, GetReply(nick, L_CIBANLVL), chaninfo->banlevel, GetBanType(chaninfo));

	csntc(nick, GetReply(nick, L_CICHMODESLVL), chaninfo->cml,
			chaninfo->bantime ? duration(chaninfo->bantime) : "Aucun");

	if(CSetWelcome(chaninfo) && *chaninfo->welcome) csntc(nick, GetReply(nick, L_CIWELCOME), chaninfo->welcome);
	if(IsAnAdmin(nick->user)) show_suspend(nick, chaninfo);
	csntc(nick, GetReply(nick, L_CIACTUALTOPIC), chaninfo->topic);

	if(see || !(chaninfo->mode.modes & C_MKEY) || getjoininfo(nick, chaninfo->chan))
		csntc(nick, GetReply(nick, L_CIACTUALMODES), chaninfo->mode.modes ? GetCModes(chaninfo->mode) : "Aucun");

	if(IsAnAdmin(nick->user)) whoison(nick, chaninfo, parc, parv);

	return 1;
}
